pub fn toUpper(cp: u21) u21 {
    return switch(cp) {
        0x0061...0x007a => cp - 0x20,
        0x00b5 => cp + 0x2e7,
        0x00e0...0x00f6 => cp - 0x20,
        0x00f8...0x00fe => cp - 0x20,
        0x00ff => cp + 0x79,
        0x0101 => cp - 0x1,
        0x0103 => cp - 0x1,
        0x0105 => cp - 0x1,
        0x0107 => cp - 0x1,
        0x0109 => cp - 0x1,
        0x010b => cp - 0x1,
        0x010d => cp - 0x1,
        0x010f => cp - 0x1,
        0x0111 => cp - 0x1,
        0x0113 => cp - 0x1,
        0x0115 => cp - 0x1,
        0x0117 => cp - 0x1,
        0x0119 => cp - 0x1,
        0x011b => cp - 0x1,
        0x011d => cp - 0x1,
        0x011f => cp - 0x1,
        0x0121 => cp - 0x1,
        0x0123 => cp - 0x1,
        0x0125 => cp - 0x1,
        0x0127 => cp - 0x1,
        0x0129 => cp - 0x1,
        0x012b => cp - 0x1,
        0x012d => cp - 0x1,
        0x012f => cp - 0x1,
        0x0131 => cp - 0xe8,
        0x0133 => cp - 0x1,
        0x0135 => cp - 0x1,
        0x0137 => cp - 0x1,
        0x013a => cp - 0x1,
        0x013c => cp - 0x1,
        0x013e => cp - 0x1,
        0x0140 => cp - 0x1,
        0x0142 => cp - 0x1,
        0x0144 => cp - 0x1,
        0x0146 => cp - 0x1,
        0x0148 => cp - 0x1,
        0x014b => cp - 0x1,
        0x014d => cp - 0x1,
        0x014f => cp - 0x1,
        0x0151 => cp - 0x1,
        0x0153 => cp - 0x1,
        0x0155 => cp - 0x1,
        0x0157 => cp - 0x1,
        0x0159 => cp - 0x1,
        0x015b => cp - 0x1,
        0x015d => cp - 0x1,
        0x015f => cp - 0x1,
        0x0161 => cp - 0x1,
        0x0163 => cp - 0x1,
        0x0165 => cp - 0x1,
        0x0167 => cp - 0x1,
        0x0169 => cp - 0x1,
        0x016b => cp - 0x1,
        0x016d => cp - 0x1,
        0x016f => cp - 0x1,
        0x0171 => cp - 0x1,
        0x0173 => cp - 0x1,
        0x0175 => cp - 0x1,
        0x0177 => cp - 0x1,
        0x017a => cp - 0x1,
        0x017c => cp - 0x1,
        0x017e => cp - 0x1,
        0x017f => cp - 0x12c,
        0x0180 => cp + 0xc3,
        0x0183 => cp - 0x1,
        0x0185 => cp - 0x1,
        0x0188 => cp - 0x1,
        0x018c => cp - 0x1,
        0x0192 => cp - 0x1,
        0x0195 => cp + 0x61,
        0x0199 => cp - 0x1,
        0x019a => cp + 0xa3,
        0x019e => cp + 0x82,
        0x01a1 => cp - 0x1,
        0x01a3 => cp - 0x1,
        0x01a5 => cp - 0x1,
        0x01a8 => cp - 0x1,
        0x01ad => cp - 0x1,
        0x01b0 => cp - 0x1,
        0x01b4 => cp - 0x1,
        0x01b6 => cp - 0x1,
        0x01b9 => cp - 0x1,
        0x01bd => cp - 0x1,
        0x01bf => cp + 0x38,
        0x01c6 => cp - 0x2,
        0x01c9 => cp - 0x2,
        0x01cc => cp - 0x2,
        0x01ce => cp - 0x1,
        0x01d0 => cp - 0x1,
        0x01d2 => cp - 0x1,
        0x01d4 => cp - 0x1,
        0x01d6 => cp - 0x1,
        0x01d8 => cp - 0x1,
        0x01da => cp - 0x1,
        0x01dc => cp - 0x1,
        0x01dd => cp - 0x4f,
        0x01df => cp - 0x1,
        0x01e1 => cp - 0x1,
        0x01e3 => cp - 0x1,
        0x01e5 => cp - 0x1,
        0x01e7 => cp - 0x1,
        0x01e9 => cp - 0x1,
        0x01eb => cp - 0x1,
        0x01ed => cp - 0x1,
        0x01ef => cp - 0x1,
        0x01f3 => cp - 0x2,
        0x01f5 => cp - 0x1,
        0x01f9 => cp - 0x1,
        0x01fb => cp - 0x1,
        0x01fd => cp - 0x1,
        0x01ff => cp - 0x1,
        0x0201 => cp - 0x1,
        0x0203 => cp - 0x1,
        0x0205 => cp - 0x1,
        0x0207 => cp - 0x1,
        0x0209 => cp - 0x1,
        0x020b => cp - 0x1,
        0x020d => cp - 0x1,
        0x020f => cp - 0x1,
        0x0211 => cp - 0x1,
        0x0213 => cp - 0x1,
        0x0215 => cp - 0x1,
        0x0217 => cp - 0x1,
        0x0219 => cp - 0x1,
        0x021b => cp - 0x1,
        0x021d => cp - 0x1,
        0x021f => cp - 0x1,
        0x0223 => cp - 0x1,
        0x0225 => cp - 0x1,
        0x0227 => cp - 0x1,
        0x0229 => cp - 0x1,
        0x022b => cp - 0x1,
        0x022d => cp - 0x1,
        0x022f => cp - 0x1,
        0x0231 => cp - 0x1,
        0x0233 => cp - 0x1,
        0x023c => cp - 0x1,
        0x023f...0x0240 => cp + 0x2a3f,
        0x0242 => cp - 0x1,
        0x0247 => cp - 0x1,
        0x0249 => cp - 0x1,
        0x024b => cp - 0x1,
        0x024d => cp - 0x1,
        0x024f => cp - 0x1,
        0x0250 => cp + 0x2a1f,
        0x0251 => cp + 0x2a1c,
        0x0252 => cp + 0x2a1e,
        0x0253 => cp - 0xd2,
        0x0254 => cp - 0xce,
        0x0256...0x0257 => cp - 0xcd,
        0x0259 => cp - 0xca,
        0x025b => cp - 0xcb,
        0x025c => cp + 0xa54f,
        0x0260 => cp - 0xcd,
        0x0261 => cp + 0xa54b,
        0x0263 => cp - 0xcf,
        0x0265 => cp + 0xa528,
        0x0266 => cp + 0xa544,
        0x0268 => cp - 0xd1,
        0x0269 => cp - 0xd3,
        0x026a => cp + 0xa544,
        0x026b => cp + 0x29f7,
        0x026c => cp + 0xa541,
        0x026f => cp - 0xd3,
        0x0271 => cp + 0x29fd,
        0x0272 => cp - 0xd5,
        0x0275 => cp - 0xd6,
        0x027d => cp + 0x29e7,
        0x0280 => cp - 0xda,
        0x0282 => cp + 0xa543,
        0x0283 => cp - 0xda,
        0x0287 => cp + 0xa52a,
        0x0288 => cp - 0xda,
        0x0289 => cp - 0x45,
        0x028a...0x028b => cp - 0xd9,
        0x028c => cp - 0x47,
        0x0292 => cp - 0xdb,
        0x029d => cp + 0xa515,
        0x029e => cp + 0xa512,
        0x0371 => cp - 0x1,
        0x0373 => cp - 0x1,
        0x0377 => cp - 0x1,
        0x037b...0x037d => cp + 0x82,
        0x03ac => cp - 0x26,
        0x03ad...0x03af => cp - 0x25,
        0x03b1...0x03c1 => cp - 0x20,
        0x03c2 => cp - 0x1f,
        0x03c3...0x03cb => cp - 0x20,
        0x03cc => cp - 0x40,
        0x03cd...0x03ce => cp - 0x3f,
        0x03d0 => cp - 0x3e,
        0x03d1 => cp - 0x39,
        0x03d5 => cp - 0x2f,
        0x03d6 => cp - 0x36,
        0x03d7 => cp - 0x8,
        0x03d9 => cp - 0x1,
        0x03db => cp - 0x1,
        0x03dd => cp - 0x1,
        0x03df => cp - 0x1,
        0x03e1 => cp - 0x1,
        0x03e3 => cp - 0x1,
        0x03e5 => cp - 0x1,
        0x03e7 => cp - 0x1,
        0x03e9 => cp - 0x1,
        0x03eb => cp - 0x1,
        0x03ed => cp - 0x1,
        0x03ef => cp - 0x1,
        0x03f0 => cp - 0x56,
        0x03f1 => cp - 0x50,
        0x03f2 => cp + 0x7,
        0x03f3 => cp - 0x74,
        0x03f5 => cp - 0x60,
        0x03f8 => cp - 0x1,
        0x03fb => cp - 0x1,
        0x0430...0x044f => cp - 0x20,
        0x0450...0x045f => cp - 0x50,
        0x0461 => cp - 0x1,
        0x0463 => cp - 0x1,
        0x0465 => cp - 0x1,
        0x0467 => cp - 0x1,
        0x0469 => cp - 0x1,
        0x046b => cp - 0x1,
        0x046d => cp - 0x1,
        0x046f => cp - 0x1,
        0x0471 => cp - 0x1,
        0x0473 => cp - 0x1,
        0x0475 => cp - 0x1,
        0x0477 => cp - 0x1,
        0x0479 => cp - 0x1,
        0x047b => cp - 0x1,
        0x047d => cp - 0x1,
        0x047f => cp - 0x1,
        0x0481 => cp - 0x1,
        0x048b => cp - 0x1,
        0x048d => cp - 0x1,
        0x048f => cp - 0x1,
        0x0491 => cp - 0x1,
        0x0493 => cp - 0x1,
        0x0495 => cp - 0x1,
        0x0497 => cp - 0x1,
        0x0499 => cp - 0x1,
        0x049b => cp - 0x1,
        0x049d => cp - 0x1,
        0x049f => cp - 0x1,
        0x04a1 => cp - 0x1,
        0x04a3 => cp - 0x1,
        0x04a5 => cp - 0x1,
        0x04a7 => cp - 0x1,
        0x04a9 => cp - 0x1,
        0x04ab => cp - 0x1,
        0x04ad => cp - 0x1,
        0x04af => cp - 0x1,
        0x04b1 => cp - 0x1,
        0x04b3 => cp - 0x1,
        0x04b5 => cp - 0x1,
        0x04b7 => cp - 0x1,
        0x04b9 => cp - 0x1,
        0x04bb => cp - 0x1,
        0x04bd => cp - 0x1,
        0x04bf => cp - 0x1,
        0x04c2 => cp - 0x1,
        0x04c4 => cp - 0x1,
        0x04c6 => cp - 0x1,
        0x04c8 => cp - 0x1,
        0x04ca => cp - 0x1,
        0x04cc => cp - 0x1,
        0x04ce => cp - 0x1,
        0x04cf => cp - 0xf,
        0x04d1 => cp - 0x1,
        0x04d3 => cp - 0x1,
        0x04d5 => cp - 0x1,
        0x04d7 => cp - 0x1,
        0x04d9 => cp - 0x1,
        0x04db => cp - 0x1,
        0x04dd => cp - 0x1,
        0x04df => cp - 0x1,
        0x04e1 => cp - 0x1,
        0x04e3 => cp - 0x1,
        0x04e5 => cp - 0x1,
        0x04e7 => cp - 0x1,
        0x04e9 => cp - 0x1,
        0x04eb => cp - 0x1,
        0x04ed => cp - 0x1,
        0x04ef => cp - 0x1,
        0x04f1 => cp - 0x1,
        0x04f3 => cp - 0x1,
        0x04f5 => cp - 0x1,
        0x04f7 => cp - 0x1,
        0x04f9 => cp - 0x1,
        0x04fb => cp - 0x1,
        0x04fd => cp - 0x1,
        0x04ff => cp - 0x1,
        0x0501 => cp - 0x1,
        0x0503 => cp - 0x1,
        0x0505 => cp - 0x1,
        0x0507 => cp - 0x1,
        0x0509 => cp - 0x1,
        0x050b => cp - 0x1,
        0x050d => cp - 0x1,
        0x050f => cp - 0x1,
        0x0511 => cp - 0x1,
        0x0513 => cp - 0x1,
        0x0515 => cp - 0x1,
        0x0517 => cp - 0x1,
        0x0519 => cp - 0x1,
        0x051b => cp - 0x1,
        0x051d => cp - 0x1,
        0x051f => cp - 0x1,
        0x0521 => cp - 0x1,
        0x0523 => cp - 0x1,
        0x0525 => cp - 0x1,
        0x0527 => cp - 0x1,
        0x0529 => cp - 0x1,
        0x052b => cp - 0x1,
        0x052d => cp - 0x1,
        0x052f => cp - 0x1,
        0x0561...0x0586 => cp - 0x30,
        0x10d0...0x10fa => cp + 0xbc0,
        0x10fd...0x10ff => cp + 0xbc0,
        0x13f8...0x13fd => cp - 0x8,
        0x1c80 => cp - 0x186e,
        0x1c81 => cp - 0x186d,
        0x1c82 => cp - 0x1864,
        0x1c83...0x1c84 => cp - 0x1862,
        0x1c85 => cp - 0x1863,
        0x1c86 => cp - 0x185c,
        0x1c87 => cp - 0x1825,
        0x1c88 => cp + 0x89c2,
        0x1d79 => cp + 0x8a04,
        0x1d7d => cp + 0xee6,
        0x1d8e => cp + 0x8a38,
        0x1e01 => cp - 0x1,
        0x1e03 => cp - 0x1,
        0x1e05 => cp - 0x1,
        0x1e07 => cp - 0x1,
        0x1e09 => cp - 0x1,
        0x1e0b => cp - 0x1,
        0x1e0d => cp - 0x1,
        0x1e0f => cp - 0x1,
        0x1e11 => cp - 0x1,
        0x1e13 => cp - 0x1,
        0x1e15 => cp - 0x1,
        0x1e17 => cp - 0x1,
        0x1e19 => cp - 0x1,
        0x1e1b => cp - 0x1,
        0x1e1d => cp - 0x1,
        0x1e1f => cp - 0x1,
        0x1e21 => cp - 0x1,
        0x1e23 => cp - 0x1,
        0x1e25 => cp - 0x1,
        0x1e27 => cp - 0x1,
        0x1e29 => cp - 0x1,
        0x1e2b => cp - 0x1,
        0x1e2d => cp - 0x1,
        0x1e2f => cp - 0x1,
        0x1e31 => cp - 0x1,
        0x1e33 => cp - 0x1,
        0x1e35 => cp - 0x1,
        0x1e37 => cp - 0x1,
        0x1e39 => cp - 0x1,
        0x1e3b => cp - 0x1,
        0x1e3d => cp - 0x1,
        0x1e3f => cp - 0x1,
        0x1e41 => cp - 0x1,
        0x1e43 => cp - 0x1,
        0x1e45 => cp - 0x1,
        0x1e47 => cp - 0x1,
        0x1e49 => cp - 0x1,
        0x1e4b => cp - 0x1,
        0x1e4d => cp - 0x1,
        0x1e4f => cp - 0x1,
        0x1e51 => cp - 0x1,
        0x1e53 => cp - 0x1,
        0x1e55 => cp - 0x1,
        0x1e57 => cp - 0x1,
        0x1e59 => cp - 0x1,
        0x1e5b => cp - 0x1,
        0x1e5d => cp - 0x1,
        0x1e5f => cp - 0x1,
        0x1e61 => cp - 0x1,
        0x1e63 => cp - 0x1,
        0x1e65 => cp - 0x1,
        0x1e67 => cp - 0x1,
        0x1e69 => cp - 0x1,
        0x1e6b => cp - 0x1,
        0x1e6d => cp - 0x1,
        0x1e6f => cp - 0x1,
        0x1e71 => cp - 0x1,
        0x1e73 => cp - 0x1,
        0x1e75 => cp - 0x1,
        0x1e77 => cp - 0x1,
        0x1e79 => cp - 0x1,
        0x1e7b => cp - 0x1,
        0x1e7d => cp - 0x1,
        0x1e7f => cp - 0x1,
        0x1e81 => cp - 0x1,
        0x1e83 => cp - 0x1,
        0x1e85 => cp - 0x1,
        0x1e87 => cp - 0x1,
        0x1e89 => cp - 0x1,
        0x1e8b => cp - 0x1,
        0x1e8d => cp - 0x1,
        0x1e8f => cp - 0x1,
        0x1e91 => cp - 0x1,
        0x1e93 => cp - 0x1,
        0x1e95 => cp - 0x1,
        0x1e9b => cp - 0x3b,
        0x1ea1 => cp - 0x1,
        0x1ea3 => cp - 0x1,
        0x1ea5 => cp - 0x1,
        0x1ea7 => cp - 0x1,
        0x1ea9 => cp - 0x1,
        0x1eab => cp - 0x1,
        0x1ead => cp - 0x1,
        0x1eaf => cp - 0x1,
        0x1eb1 => cp - 0x1,
        0x1eb3 => cp - 0x1,
        0x1eb5 => cp - 0x1,
        0x1eb7 => cp - 0x1,
        0x1eb9 => cp - 0x1,
        0x1ebb => cp - 0x1,
        0x1ebd => cp - 0x1,
        0x1ebf => cp - 0x1,
        0x1ec1 => cp - 0x1,
        0x1ec3 => cp - 0x1,
        0x1ec5 => cp - 0x1,
        0x1ec7 => cp - 0x1,
        0x1ec9 => cp - 0x1,
        0x1ecb => cp - 0x1,
        0x1ecd => cp - 0x1,
        0x1ecf => cp - 0x1,
        0x1ed1 => cp - 0x1,
        0x1ed3 => cp - 0x1,
        0x1ed5 => cp - 0x1,
        0x1ed7 => cp - 0x1,
        0x1ed9 => cp - 0x1,
        0x1edb => cp - 0x1,
        0x1edd => cp - 0x1,
        0x1edf => cp - 0x1,
        0x1ee1 => cp - 0x1,
        0x1ee3 => cp - 0x1,
        0x1ee5 => cp - 0x1,
        0x1ee7 => cp - 0x1,
        0x1ee9 => cp - 0x1,
        0x1eeb => cp - 0x1,
        0x1eed => cp - 0x1,
        0x1eef => cp - 0x1,
        0x1ef1 => cp - 0x1,
        0x1ef3 => cp - 0x1,
        0x1ef5 => cp - 0x1,
        0x1ef7 => cp - 0x1,
        0x1ef9 => cp - 0x1,
        0x1efb => cp - 0x1,
        0x1efd => cp - 0x1,
        0x1eff => cp - 0x1,
        0x1f00...0x1f07 => cp + 0x8,
        0x1f10...0x1f15 => cp + 0x8,
        0x1f20...0x1f27 => cp + 0x8,
        0x1f30...0x1f37 => cp + 0x8,
        0x1f40...0x1f45 => cp + 0x8,
        0x1f51 => cp + 0x8,
        0x1f53 => cp + 0x8,
        0x1f55 => cp + 0x8,
        0x1f57 => cp + 0x8,
        0x1f60...0x1f67 => cp + 0x8,
        0x1f70...0x1f71 => cp + 0x4a,
        0x1f72...0x1f75 => cp + 0x56,
        0x1f76...0x1f77 => cp + 0x64,
        0x1f78...0x1f79 => cp + 0x80,
        0x1f7a...0x1f7b => cp + 0x70,
        0x1f7c...0x1f7d => cp + 0x7e,
        0x1f80...0x1f87 => cp + 0x8,
        0x1f90...0x1f97 => cp + 0x8,
        0x1fa0...0x1fa7 => cp + 0x8,
        0x1fb0...0x1fb1 => cp + 0x8,
        0x1fb3 => cp + 0x9,
        0x1fbe => cp - 0x1c25,
        0x1fc3 => cp + 0x9,
        0x1fd0...0x1fd1 => cp + 0x8,
        0x1fe0...0x1fe1 => cp + 0x8,
        0x1fe5 => cp + 0x7,
        0x1ff3 => cp + 0x9,
        0x214e => cp - 0x1c,
        0x2184 => cp - 0x1,
        0x2c30...0x2c5f => cp - 0x30,
        0x2c61 => cp - 0x1,
        0x2c65 => cp - 0x2a2b,
        0x2c66 => cp - 0x2a28,
        0x2c68 => cp - 0x1,
        0x2c6a => cp - 0x1,
        0x2c6c => cp - 0x1,
        0x2c73 => cp - 0x1,
        0x2c76 => cp - 0x1,
        0x2c81 => cp - 0x1,
        0x2c83 => cp - 0x1,
        0x2c85 => cp - 0x1,
        0x2c87 => cp - 0x1,
        0x2c89 => cp - 0x1,
        0x2c8b => cp - 0x1,
        0x2c8d => cp - 0x1,
        0x2c8f => cp - 0x1,
        0x2c91 => cp - 0x1,
        0x2c93 => cp - 0x1,
        0x2c95 => cp - 0x1,
        0x2c97 => cp - 0x1,
        0x2c99 => cp - 0x1,
        0x2c9b => cp - 0x1,
        0x2c9d => cp - 0x1,
        0x2c9f => cp - 0x1,
        0x2ca1 => cp - 0x1,
        0x2ca3 => cp - 0x1,
        0x2ca5 => cp - 0x1,
        0x2ca7 => cp - 0x1,
        0x2ca9 => cp - 0x1,
        0x2cab => cp - 0x1,
        0x2cad => cp - 0x1,
        0x2caf => cp - 0x1,
        0x2cb1 => cp - 0x1,
        0x2cb3 => cp - 0x1,
        0x2cb5 => cp - 0x1,
        0x2cb7 => cp - 0x1,
        0x2cb9 => cp - 0x1,
        0x2cbb => cp - 0x1,
        0x2cbd => cp - 0x1,
        0x2cbf => cp - 0x1,
        0x2cc1 => cp - 0x1,
        0x2cc3 => cp - 0x1,
        0x2cc5 => cp - 0x1,
        0x2cc7 => cp - 0x1,
        0x2cc9 => cp - 0x1,
        0x2ccb => cp - 0x1,
        0x2ccd => cp - 0x1,
        0x2ccf => cp - 0x1,
        0x2cd1 => cp - 0x1,
        0x2cd3 => cp - 0x1,
        0x2cd5 => cp - 0x1,
        0x2cd7 => cp - 0x1,
        0x2cd9 => cp - 0x1,
        0x2cdb => cp - 0x1,
        0x2cdd => cp - 0x1,
        0x2cdf => cp - 0x1,
        0x2ce1 => cp - 0x1,
        0x2ce3 => cp - 0x1,
        0x2cec => cp - 0x1,
        0x2cee => cp - 0x1,
        0x2cf3 => cp - 0x1,
        0x2d00...0x2d25 => cp - 0x1c60,
        0x2d27 => cp - 0x1c60,
        0x2d2d => cp - 0x1c60,
        0xa641 => cp - 0x1,
        0xa643 => cp - 0x1,
        0xa645 => cp - 0x1,
        0xa647 => cp - 0x1,
        0xa649 => cp - 0x1,
        0xa64b => cp - 0x1,
        0xa64d => cp - 0x1,
        0xa64f => cp - 0x1,
        0xa651 => cp - 0x1,
        0xa653 => cp - 0x1,
        0xa655 => cp - 0x1,
        0xa657 => cp - 0x1,
        0xa659 => cp - 0x1,
        0xa65b => cp - 0x1,
        0xa65d => cp - 0x1,
        0xa65f => cp - 0x1,
        0xa661 => cp - 0x1,
        0xa663 => cp - 0x1,
        0xa665 => cp - 0x1,
        0xa667 => cp - 0x1,
        0xa669 => cp - 0x1,
        0xa66b => cp - 0x1,
        0xa66d => cp - 0x1,
        0xa681 => cp - 0x1,
        0xa683 => cp - 0x1,
        0xa685 => cp - 0x1,
        0xa687 => cp - 0x1,
        0xa689 => cp - 0x1,
        0xa68b => cp - 0x1,
        0xa68d => cp - 0x1,
        0xa68f => cp - 0x1,
        0xa691 => cp - 0x1,
        0xa693 => cp - 0x1,
        0xa695 => cp - 0x1,
        0xa697 => cp - 0x1,
        0xa699 => cp - 0x1,
        0xa69b => cp - 0x1,
        0xa723 => cp - 0x1,
        0xa725 => cp - 0x1,
        0xa727 => cp - 0x1,
        0xa729 => cp - 0x1,
        0xa72b => cp - 0x1,
        0xa72d => cp - 0x1,
        0xa72f => cp - 0x1,
        0xa733 => cp - 0x1,
        0xa735 => cp - 0x1,
        0xa737 => cp - 0x1,
        0xa739 => cp - 0x1,
        0xa73b => cp - 0x1,
        0xa73d => cp - 0x1,
        0xa73f => cp - 0x1,
        0xa741 => cp - 0x1,
        0xa743 => cp - 0x1,
        0xa745 => cp - 0x1,
        0xa747 => cp - 0x1,
        0xa749 => cp - 0x1,
        0xa74b => cp - 0x1,
        0xa74d => cp - 0x1,
        0xa74f => cp - 0x1,
        0xa751 => cp - 0x1,
        0xa753 => cp - 0x1,
        0xa755 => cp - 0x1,
        0xa757 => cp - 0x1,
        0xa759 => cp - 0x1,
        0xa75b => cp - 0x1,
        0xa75d => cp - 0x1,
        0xa75f => cp - 0x1,
        0xa761 => cp - 0x1,
        0xa763 => cp - 0x1,
        0xa765 => cp - 0x1,
        0xa767 => cp - 0x1,
        0xa769 => cp - 0x1,
        0xa76b => cp - 0x1,
        0xa76d => cp - 0x1,
        0xa76f => cp - 0x1,
        0xa77a => cp - 0x1,
        0xa77c => cp - 0x1,
        0xa77f => cp - 0x1,
        0xa781 => cp - 0x1,
        0xa783 => cp - 0x1,
        0xa785 => cp - 0x1,
        0xa787 => cp - 0x1,
        0xa78c => cp - 0x1,
        0xa791 => cp - 0x1,
        0xa793 => cp - 0x1,
        0xa794 => cp + 0x30,
        0xa797 => cp - 0x1,
        0xa799 => cp - 0x1,
        0xa79b => cp - 0x1,
        0xa79d => cp - 0x1,
        0xa79f => cp - 0x1,
        0xa7a1 => cp - 0x1,
        0xa7a3 => cp - 0x1,
        0xa7a5 => cp - 0x1,
        0xa7a7 => cp - 0x1,
        0xa7a9 => cp - 0x1,
        0xa7b5 => cp - 0x1,
        0xa7b7 => cp - 0x1,
        0xa7b9 => cp - 0x1,
        0xa7bb => cp - 0x1,
        0xa7bd => cp - 0x1,
        0xa7bf => cp - 0x1,
        0xa7c1 => cp - 0x1,
        0xa7c3 => cp - 0x1,
        0xa7c8 => cp - 0x1,
        0xa7ca => cp - 0x1,
        0xa7d1 => cp - 0x1,
        0xa7d7 => cp - 0x1,
        0xa7d9 => cp - 0x1,
        0xa7f6 => cp - 0x1,
        0xab53 => cp - 0x3a0,
        0xab70...0xabbf => cp - 0x97d0,
        0xff41...0xff5a => cp - 0x20,
        0x10428...0x1044f => cp - 0x28,
        0x104d8...0x104fb => cp - 0x28,
        0x10597...0x105a1 => cp - 0x27,
        0x105a3...0x105b1 => cp - 0x27,
        0x105b3...0x105b9 => cp - 0x27,
        0x105bb...0x105bc => cp - 0x27,
        0x10cc0...0x10cf2 => cp - 0x40,
        0x118c0...0x118df => cp - 0x20,
        0x16e60...0x16e7f => cp - 0x20,
        0x1e922...0x1e943 => cp - 0x22,
        else => cp,
    };
}
